<?php
/**
* Updates the company associated with a job post.
 *
 * @param int $post_id The ID of the job post to update.
*/
function update_job_company($post_id)
{

    //check if post type is job
    if (get_post_type($post_id) != 'job')
        return;

    //Make sure this is definitely an ACF field group
    if (empty($_POST['acf']) || !is_array($_POST['acf'])) {
        return;
    }

    //Field key for the 'company_id' field
    $company_id_field = 'field_66a883b01905b';


    //Is 'company_id' is set
    if (isset($_POST['acf'][$company_id_field])) {
        $company_id = $_POST['acf'][$company_id_field];
        if (isset($company_id) && !empty($company_id)) {

            //Get the title of cpt company based on the ID
            $company_title = get_the_title($company_id);

            update_field('customer_company', $company_title, $post_id);
        }
    }
}

//Run the function when saving an acf
add_action('acf/save_post', 'update_job_company', 20);
