import { BarModel } from "../models/bar";

export const Bar = Backbone.Collection.extend({
    model: BarModel,
    url: function () {
        return `${dp_args.restUrl}leadgen/v1/jobs/filter/bar`;
    },
    initialize: function (options) {
        this.eventEmitter = options.eventEmitter;
        this.listenTo(
            this.eventEmitter,
            'updateJobs',
            this.fetchBar.bind(this)
        );
    },

    fetchBar: function (data) {
        console.log(data);

        this.fetch({
            model: BarModel,
            data: data,
            processData: true,   // jQuery will convert data to a query string
            beforeSend: function (xhr) {
            },
            success: (collection, response, options) => {
                this.setBar(response.html)
            },
            error: function (collection, response, options) {
                console.error('Error:', options);
            }
        });
    },
    setBar: function (response) {
        const bar = document.getElementById('filter_selected_bar_selections');
        bar.innerHTML = '';
        if (bar) {
            bar.innerHTML = response;
        }
    },
    setBarEvents: function () {

    }
});