import { SidebarModel } from "../models/sidebar";

export const Sidebar = Backbone.Collection.extend({
    model: SidebarModel,
    url: function () {
        return `${dp_args.restUrl}leadgen/v1/jobs/filter/sidebar`;
    },
    initialize: function (options) {
        this.eventEmitter = options.eventEmitter;
        this.terms = [
            'job_type',
            'job_working_time',
            'job_form_of_employment'
        ];

        this.listenTo(
            this.eventEmitter,
            'updateJobs',
            this.fetchSidebar.bind(this)
        );
    },
    getTaxonomies: function (ID) {
        const dpForms = document.getElementsByClassName("dp-form-" + ID);
        let combinedResult = [];
        Array.from(dpForms).forEach((dpForm) => {

            const data = new FormData(dpForm);
            const dataObject = Object.fromEntries(data.entries());
            let NameArray = Object.keys(dataObject).filter(key => key.endsWith('_terms'));
            combinedResult = combinedResult.concat(NameArray);

        });
        let terms = [];

        combinedResult.forEach((name) => {
            this.terms.forEach((term) => {
                console.log(name.indexOf(term) !== -1);
                if (name.indexOf(term) !== -1) {
                    terms.push(term);
                }
            })
        })
        return terms;
    },
    getOpenedAccordion: function (id) {
        const sidebar = document.getElementsByClassName('sidebar')[0]
        const accordions = sidebar.getElementsByClassName('uk-accordion-title');
        Array.from(accordions).forEach((accordion) => {
            if (accordion.parentNode.classList.contains('uk-open')) {

                return accordion.parentNode.id

            }
        });
    },
    fetchSidebar: function (data) {

        let terms = this.getTaxonomies(data.ID);
        console.log(data);

        this.fetch({
            model: SidebarModel,
            data: data,
            processData: true,   // jQuery will convert data to a query string
            beforeSend: function (xhr) {
            },
            success: (collection, response, options) => {

                for (let tax in response) {
                    if (terms.indexOf(tax) >= 0) {
                        continue;
                    }
                    else if (('dates' == tax) && ('city' in data)) {
                        for (let term_id in response[tax]) {

                            let span = document.getElementById('term_count_' + term_id);

                            if (span) {
                                span.textContent = response[tax][term_id];
                            }
                        }
                    }
                    else if (('dates' == tax) && ('s' in data)) {
                        for (let term_id in response[tax]) {

                            let span = document.getElementById('term_count_' + term_id);

                            if (span) {
                                span.textContent = response[tax][term_id];
                            }
                        }
                    }

                    else {
                        for (let term_id in response[tax]) {
                            let span = document.getElementById('term_count_' + term_id);
                            if (span) {
                                span.textContent = response[tax][term_id];
                            }
                        }
                    }
                }
                return response
            },
            error: function (collection, response, options) {
                console.error('Error:', options);
            }
        });
    },

});