import set_event_watcher from "./wishlist";
import * as EventEmitter from 'events';
import { JobCollection } from "./collections/jobs";
import { Sidebar } from "./collections/sidebars";
import { Bar } from "./collections/bars";
import { LeadgenSelection } from "./models/selection";
import { scrollToTop } from "./scrolltotop";
function SortMultiValues(entries) {
    let array = []
    for (let i = 0; i < entries.length; i++) {
        array.push(entries[i])
    }
    return array
}

const eventEmitter = new EventEmitter();



class LeadgenFilter {
    constructor(options) {
        this.eventEmitter = options.eventEmitter;
        this.dp_form_class = options.db_form_class;
        options.filter = this;
        this.LeadgenSelection = new LeadgenSelection(options);
        this.input_types = 'input, select, textarea, checkbox';
        this.bl_input_ids = [
            'searchBox', 'searchInput', 'city', 'distanceDropdown'
        ]
        this.jobs = new JobCollection(options);
        this.jobs.listenTo(
            this.eventEmitter,
            'paginationEvent',
            this.setPaginationEvents
        );
  

    }



    /**
     * 
     * set Events
     * 
     */
    setEvents() {
    
        let elements = document.getElementsByName('dates');
  
        if (elements) {
            Array.from(elements).forEach((element) => {
                element.addEventListener('change', (e) => {

                    // If the current target was changed from checked to not checked
                    if (!e.target.checked) {
                        e.target.checked = false;
                    } else {
                        //Deselect all other checkboxes except the one currently checked
                        Array.from(elements).forEach((checkbox) => {
                            if (checkbox !== e.target) {
                                checkbox.checked = false;
                            }
                        });
                    }
                });
            });
        }
    
        const dpForms = document.getElementsByClassName(this.dp_form_class);
     
        Array.from(dpForms).forEach((dpForm) => {
          
            let inputs = dpForm.querySelectorAll(this.input_types);
            let sidebar_inputs= document.querySelector('.sidebar').querySelectorAll("input");


            Array.from(sidebar_inputs).forEach((input) => {
    
                if (!this.bl_input_ids.includes(input.id))
                    input.addEventListener('change', (e) => this.handleChangeEvent(e, dpForm));
            });

            Array.from(inputs).forEach((input) => {
    
                if (!this.bl_input_ids.includes(input.id))
                    input.addEventListener('change', (e) => this.handleChangeEvent(e, dpForm));
            });

            dpForm.addEventListener("submit", (e) => this.handleChangeEvent(e, dpForm));
        });

    }
    handle_job(data, ID, event) {
        self = this;

        const jobs = this.jobs

        jobs.currentPage = data.page
        jobs.setContainers(ID);
        console.log(ID)
        /**
        if (event) {
            if (event.name == 'dates') {
                //  jobs.updateSidebar(data, ID)
            }
            if (event.tagName == 'FORM') {
                // jobs.updateSidebar(data, ID)
            }
            //jobs.updateSidebar(data, ID)
        }
 */


        const successFunc = function (collection, response, options) {


            self.eventEmitter.emit('updateJobs', data);
            return data;
        }.bind(ID);

        const errorFunc = function (collection, response, options) {
            console.error('Error:', options);
        }.bind(ID);

        const completeFunc = function (xhr, textStatus) {

            set_event_watcher();

            jobs.updatePagination(xhr.getResponseHeader('x-wp-total'), data.per_page, jobs.currentPage, this)

            jobs.updateCount(xhr.getResponseHeader('x-wp-total'), data, ID);



            // updateSidebarCount(ID);

        }.bind(ID);
        data.ID = ID

        jobs.fetch({
            data: jQuery.param({ ...data }),
            beforeSend: function (xhr) { },
            success: successFunc,
            error: errorFunc,
            complete: completeFunc
        });
    }

    splitID(classes) {
        let ID = classes.find(cls => cls.startsWith('dp-form-')).split('-')[2];
        return ID;
    }
    getID(form) {
      
        let classes = form.getAttribute("class").split(' ');
        return this.splitID(classes);
    }

    handleChangeEvent(e, form) {
        e.preventDefault();
        if (
            e.target.id
        ) {
            const tit = document.querySelectorAll('#' + e.target.id);
            const value = e.target.checked;

            tit.forEach((term) => {
                term.checked = value;

            })
        }

        let ID = this.getID(form)
        console.log('ID', ID, form)
        const dpForms = document.querySelectorAll('.dp-form-' + ID);

        let selectArrays = {}
        let combinedResult = {};

        Array.from(dpForms).forEach((dpForm) => {
            let result = this.getFormData(dpForm);
            let selectArray = Object.keys(result)
                .filter(key => key.startsWith('select_'))

            if (selectArray.length > 0) {
                selectArray.forEach((key) => {
                    if (selectArrays[key] == undefined) {
                        selectArrays[key] = []
                    }
                    selectArrays[key].push(result[key])
                })
            }
            combinedResult = Object.assign(combinedResult, result);
        });


        combinedResult = Object.assign(combinedResult, selectArrays);
        combinedResult = Object.assign(combinedResult, getShortcodeFormData(dpForms[0]));
      
        this.handle_job(combinedResult, ID, e.target)
        scrollToTop(document.getElementById('dp-output-'+ ID))
        
    }

    getFormData(form) {
        const data = new FormData(form);
        const trimCommasAndWhitespace = (str) => {
            return str.trim().split(',').filter(item => item).join(',');
        }

        let obj = {};

        obj['select_jobcategory'] = SortMultiValues(data.getAll('jobcategory')).toString();
        obj['select_job_form_of_employment'] = SortMultiValues(data.getAll('job_form_of_employment')).toString();
        obj['select_job_type'] = SortMultiValues(data.getAll('job_type')).toString();
        obj['select_job_working_time'] = (SortMultiValues(data.getAll('job_working_time')).toString());


        obj['orderby'] = data.get('orderby')
        obj['order'] = data.get('order')
        obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory_jobcategory_terms')).toString();

        obj['job_type'] = SortMultiValues(data.getAll('job_type_job_type_terms')).toString();
        obj['form_of_employment_terms'] = SortMultiValues(data.getAll('job_form_of_employment_job_form_of_employment_terms')).toString()
        obj['working_time_terms'] = SortMultiValues(data.getAll('job_working_time_job_working_time_terms')).toString()
        obj['s'] = data.get('s');
        obj['per_page'] = data.get('per_page');
        obj['distance'] = data.get('distance');
        obj['latitude'] = data.get('latitude');
        obj['longitude'] = data.get('longitude');
        obj['dates'] = data.get('dates');

        if (dp_args && dp_args['activeTerm']) {
            obj['jobcategory'] = trimCommasAndWhitespace(obj['jobcategory'] = obj['jobcategory'] + ',' + dp_args['activeTerm']);
        }
        return Object.fromEntries(Object.entries(obj).filter(([_, v]) => v != null && v != ''));
    }


    /**
     * 
     * setPaginationEvents
     * 
     */
    setPaginationEvents() {
        self = this;
        let paginationElements = document.querySelectorAll('.pagination ul li span');

        Array.from(paginationElements).forEach((elem) => {
            elem.addEventListener('click', function (e) {
                let clickedPage = this.getAttribute('data-page');
                if (clickedPage) {
                  
                    const pagination_ID = this.getAttribute('data-id');

                    const ID = pagination_ID.split('pagination_')[0]
               
                    const dpForms = document.querySelectorAll('.dp-form-' + ID);

                    let combinedResult = {};
                    let ShData = getShortcodeFormData(dpForms[0])

                    Array.from(dpForms).forEach((dpForm) => {

                        let result = self.getFormData(dpForm)
                        combinedResult = Object.assign(combinedResult, result);

                    });
                    combinedResult = Object.assign(combinedResult, ShData);


                    combinedResult['page'] = parseInt(clickedPage);

                    self.handle_job(combinedResult, ID, e.target);
                    scrollToTop(document.getElementById('dp-output-'+ ID))
                }
            });

            
        });
    }
  /*  setScrollEvents() {
        self = this;

        let ids = []
        const dpForms = document.getElementsByClassName('dp-form');
        Array.from(dpForms).forEach((dpForm) => {
            ids.push(this.getID(dpForm))
       
        });
        const Ids = [... new Set(ids)]
        Ids.forEach((id) => {

            new ScrollToTop(
                'searchBtn', id
            )
        })

    }
        */
}


document.addEventListener('DOMContentLoaded', (event) => {
    const sidebar = document.getElementsByClassName('sidebar')[0]

    if (sidebar == undefined) {
        return;
    }
    const accordions = sidebar.getElementsByClassName('uk-accordion-title');
    Array.from(accordions).forEach((accordion) => {
      
        accordion.addEventListener('click', function (event) {
            let parentId = event.target.parentNode.id;
            if (parentId == 'dates') {
                return;
            }

            if (parentId == 'jobcategory' || parentId == 'job_type' || parentId == 'job_form_of_employment' || parentId == 'job_working_time') {
                updateSidebarCount(parentId);
            }

        });
    });


});






function getShortcodeFormData(form) {
    const data = new FormData(form);


    const trimCommasAndWhitespace = (str) => {

        return str.trim().split(',').filter(item => item).join(',');
    }


    let obj = {};


    obj['city'] = data.get('city')
    obj['orderby'] = data.get('orderby')
    obj['order'] = data.get('order')
    obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory')).toString();
    obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory_jobcategory_terms')).toString();

    obj['job_type'] = SortMultiValues(data.getAll('job_type')).toString();
    obj['form_of_employment_terms'] = SortMultiValues(data.getAll('job_form_of_employment_job_form_of_employment_terms')).toString()
    obj['working_time_terms'] = SortMultiValues(data.getAll('job_working_time_job_working_time_terms')).toString()
    obj['s'] = data.get('s');
    obj['per_page'] = data.get('per_page');
    obj['distance'] = data.get('distance');
    obj['latitude'] = data.get('latitude');
    obj['longitude'] = data.get('longitude');
    obj['dates'] = data.get('dates');
    obj['company_id'] = data.get('company_id');

    if (dp_args && dp_args['activeTerm']) {
        obj['jobcategory'] = trimCommasAndWhitespace(obj['jobcategory'] = obj['jobcategory'] + ',' + dp_args['activeTerm']);
        obj['activeTerm'] = dp_args['activeTerm'];
    }

    if (dp_args && dp_args['activeTermTaxonomy']) {
        obj['activeTermTaxonomy'] = dp_args['activeTermTaxonomy'];
    }


    return Object.fromEntries(Object.entries(obj).filter(([_, v]) => v != null && v != ''));
}


document.addEventListener('DOMContentLoaded', (event) => {
 
    let options = {
        db_form_class: 'dp-form',
        eventEmitter: eventEmitter,
    }
    const bar = new Bar(options);
    const sidebar = new Sidebar(options);
    const filter = new LeadgenFilter(options);
    filter.setPaginationEvents();
    filter.setEvents();

    let delete_search_selected = function (object) {
        filter.LeadgenSelection.delete_search_selected(object)
    }

    let delete_selected = function (object) {
        filter.LeadgenSelection.delete_selected(object)
    }
    window.delete_selected = delete_selected
    window.delete_search_selected = delete_search_selected
  
});









jQuery(document).ready(function () {

    let button = document.getElementById("sortButton");
    if (button) {
        // Add event listener for click event
        button.addEventListener("click", function (e) {

            // Get icon by ID
            let icon = document.getElementById("sortIcon");
            let input = document.getElementById("order");

            // Check the current icon and switch
            if (icon.getAttribute("uk-icon") === "icon: arrow-down; ratio: 1.2") {
                icon.setAttribute("uk-icon", "icon: arrow-up; ratio: 1.2");
                input.value = "desc"; // change sort order to descending
            } else {
                icon.setAttribute("uk-icon", "icon: arrow-down; ratio: 1.2");
                input.value = "asc"; // change sort order to ascending
            }

            const dpForms = document.getElementsByClassName('dp-form');

            // Combined object 
            let combinedResult = {};
            Array.from(dpForms).forEach((dpForm) => {
                let result = getFormData(dpForm);

                // Combine the result object into the combinedResult
                combinedResult = Object.assign(combinedResult, result);

            });
       
            Filter.handle_job(combinedResult, id, e.target);

        });
    }
});









