
export const LeadgenSelection = class LeadgenSelection {
    constructor(options) {
        this.eventEmitter = options.eventEmitter;
        this.form_id = options.form_id;
        this.form = document.getElementById(this.form_id);
        this.bar = '';
        this.filter = options.filter;
        this.dp_form_class = options.db_form_class;
        this.dp_forms = document.getElementsByClassName(this.dp_form_class);
        this.jobcategory_filter_select = document.getElementById("jobcategory_filter_select");
    }

    delete_search_selected(obj) {
        let combinedResult = {};
        Array.from(this.dp_forms).forEach((dpForm) => {
            let result = this.filter.getFormData(dpForm);
            if (result.s) {
                delete result.s;
                jQuery('.searchFormWrapper').each(function () {
                    // Find the input field with name 's'
                    var inputS = jQuery(this).find('input[name=s]');
                    // Replace input value and set placeholder
                    inputS.val('');
                    inputS.attr('placeholder', 'Suche');
                });
            }
            combinedResult = Object.assign(combinedResult, result);
        });

        const FormElements = document.querySelectorAll('form[class*="dp-form-"]');
        let classes = FormElements[0].getAttribute("class").split(' ');
        let id = classes.find(cls => cls.startsWith('dp-form-')).split('-')[2];
        this.filter.handle_job(combinedResult, id);
    }

    delete_selected(obj) {
        const FormElements = document.querySelectorAll('form[class*="dp-form-"]');
        let classes = FormElements[0].getAttribute("class").split(' ');
        let id = classes.find(cls => cls.startsWith('dp-form-')).split('-')[2];
        const dpForms = document.getElementsByClassName('dp-form-' + id);
        this.resetSelection(obj);
        let combinedResult = {};
        Array.from(dpForms).forEach((dpForm) => {
            let result = this.filter.getFormData(dpForm);
            combinedResult = Object.assign(combinedResult, result);
        });
        this.filter.handle_job(combinedResult, id);
    }

    parse_throught_selected_bar() {
        let jobcategory_filter_select = document.getElementById(this.jobcategory_filter_select);
        if (jobcategory_filter_select) {
            for (let i = 0; i < jobcategory_filter_select.children.length; i++) {
                jobcategory_filter_select.children[i].addEventListener("click", function (event) {
                    this.delete_selected(event);
                }
                );
            }
        }
    }
    resetSelection(selectedOption) {
        if (selectedOption.classList.contains("city")) {
            let city = document.getElementById("city");
            var searchBox = document.getElementById('searchInput');
            document.getElementById('latitude').value = '';
            document.getElementById('longitude').value = '';
            searchBox.value = '';
            city.value = '';
            document.getElementById('CityclearButton').style.display = 'none';
        }


        else if (selectedOption.hasAttribute('data-id')) {
            let option_id = selectedOption.getAttribute('data-id');

            if (option_id == dp_args.activeTerm) {
                window.location.href = dp_args.jobArchive
            } else {

                if (selectedOption.classList.contains("datefilter")) {
                    let checkbox = document.getElementById("date_" + option_id);
                    if (checkbox) {
                        checkbox.checked = false;
                        let all_checkbox = document.getElementById("date_-9000");
                        all_checkbox.checked = true;
                    }
                }
                else {

                    let checkbox = jQuery("input[id$='term_" + option_id + "']");
                    if (checkbox) {
                        //checkbox.checked = false;
                        checkbox.prop('checked', false);
                    }

                }


            }
            if (option_id) {
                selectedOption.remove()
            }

        }
    }
};