<?php
/**
 * Class GeoCordinateCalculator
 * @package LeadGenerator
 *
 * @since 0.2.1
 */

class GeoCordinateCalculator
{
    /**
     * Constructor for the class.
     * 
     * This method is automatically called when an object of this class is created.
     * It sets up an action to be executed when a save event occurs.
     * 
     * @return void
     */
    /**
     * Constructor method for the class.
     */
    function __construct()
    {
        //   add_action('save_')

    }


}


class GoogleAdress
{
    public $address = [];
    /**
     * Constructor for the class.
     * 
     * This method is automatically called when an object of this class is created.
     * It sets up an action to be executed when a save event occurs.
     * 
     * @return void
     */
    /**
     * Constructor method for the class.
     */
    function __construct()
    {

    }
}


class GeoAdress
{
    public $address = [];
    /**
     * Constructor for the class.
     * 
     * This method is automatically called when an object of this class is created.
     * It sets up an action to be executed when a save event occurs.
     * 
     * @return void
     */
    /**
     * Constructor method for the class.
     */
    function __construct()
    {

    }
    /**
     * Validates the given address data and returns a formatted address array.
     *
     * @param array $data The address data to be validated.
     * @return array The formatted address array.
     */
    static function validate_adress($data)
    {
        $address = [
            'city' => '',
            'zip' => '',
            'district' => '',
            'latitude' => '',
            'longitude' => '',
            'country' => 'Deutschland',
            'street' => ''
        ];
        foreach ($address as $key => $value) {
            if ($data[$key] && isset($data[$key])) {
                $address[$key] = $data[$key];
            }
        }

        return $address;
    }
    /**
     * Updates the address fields for a given post ID.
     *
     * @param array $address An array of address fields to update.
     * @param int $id The post ID to update the address for.
     * @return void
     */
    static function set_adress($address, $id)
    {
        foreach ($address as $key => $value) {
            update_field($key, $value, $id);
        }
    }

}


class Nominatim
{
    private $base_url;
    const BASE_URL = 'https://nominatim.openstreetmap.org/search?';
    /**
     * Geocodes a given city using the API provided by the BASE_URL.
     *
     * @param string $city The city to be geocoded.
     * @return array An array containing the geocoded data for the given city.
     */
    public static function geocode_city($city)
    {


        // url encode the address
        $city = urlencode($city);
        $args = array(
            'format' => 'json',
            //    'addressdetails' => 1,
            'city' => $city . '*',
            'limit' => 100,
            'country' => 'Germany',
        );


        $url = add_query_arg($args, self::BASE_URL);

        $response = wp_remote_get(
            $url,
            array(
                'user-agent' => get_site_url()
            )
        );


        $api_response = json_decode(wp_remote_retrieve_body($response), true);
        return $api_response;

        if (isset($api_response[0]['lat']) && isset($api_response[0]['lon'])) {
            $addresses = [];
            foreach ($api_response as $address) {
                $data = array(
                    'zip' => $address['address']['postcode'],
                    'city' => $address['address']['town'],
                    'lat' => $address['lat'],
                    'lon' => $address['lon']
                );
                $addresses[] = $data;
            }
            return new WP_REST_Response(
                [
                    'status' => 200,
                    'addresses' => $api_response

                ]
            );


        }
        return [];
    }
    /**
     * Retrieves latitude, longitude, and address information from a given zip code.
     *
     * @param string $zip The zip code to retrieve information for.
     * @return array An array containing the latitude, longitude, and address information for the given zip code.
     */
    public static function get_info_from_postcode($zip)
    {

        // url encode the address
        $address = urlencode($zip);
        $args = array(
            'format' => 'json',
            'addressdetails' => 1,
            'postalcode' => $zip,

            'limit' => 1

        );


        $url = add_query_arg($args, self::BASE_URL);

        $response = wp_remote_get(
            $url,
            array(
                'user-agent' => get_site_url()
            )
        );


        $api_response = json_decode(wp_remote_retrieve_body($response), true);
        //	var_dump($api_response[0]['lat']);
        if (isset($api_response[0]['lat']) && isset($api_response[0]['lon'])) {

            $data = array(
                'lat' => $api_response[0]['lat'],
                'lon' => $api_response[0]['lon'],
                'addess' => $api_response[0]['address'],

            );

            return $data;
        }
        return [];
    }
    /**
     * Reverse geocodes the given latitude and longitude coordinates.
     *
     * @param float $lat The latitude coordinate.
     * @param float $lon The longitude coordinate.
     *
     * @return array An array containing the latitude, longitude, and address information from the API response.
     */
    public static function reverseGeocode($lat, $lon)
    {
        // url encode the lat and lon
        $lat = urlencode($lat);
        $lon = urlencode($lon);

        $args = array(
            'format' => 'json',
            'lat' => $lat,
            'lon' => $lon,
            'addressdetails' => 1,
        );

        $url = add_query_arg($args, 'https://nominatim.openstreetmap.org/reverse');

        $response = wp_remote_get(
            $url,
            array(
                'user-agent' => get_site_url()
            )
        );

        $api_response = json_decode(wp_remote_retrieve_body($response), true);

        //Check if 'address' is set in the response
        if (isset($api_response['address'])) {

            $data = array(
                'lat' => $lat,
                'lon' => $lon,
                'address' => $api_response['address'],
            );

            return $data;
        }
        return [];
    }
    /**
     * Geocodes the given address and returns an array of relevant data.
     *
     * @param string $address The address to be geocoded.
     * @return array An array of relevant data, including zip, city, and name.
     */    /**
          * Geocodes the given address and returns the latitude, longitude, and address details.
          *
          * @param string $address The address to be geocoded.
          * @return array An array containing the latitude, longitude, and address details. If no results are found, an empty array is returned.
          */
    public static function geocode($address)
    {

        // url encode the address
        $address = urlencode($address);

        $args = array(
            'format' => 'json',
            'addressdetails' => 1,
            'q' => $address . ' Deutschland',
            'limit' => 1
        );


        $url = add_query_arg($args, self::BASE_URL);

        $response = wp_remote_get(
            $url,
            array(
                'user-agent' => get_site_url()
            )
        );


        $api_response = json_decode(wp_remote_retrieve_body($response), true);
        //	var_dump($api_response[0]['lat']);
        if (isset($api_response[0]['lat']) && isset($api_response[0]['lon'])) {

            $data = array(
                'lat' => $api_response[0]['lat'],
                'lon' => $api_response[0]['lon'],
                'addess' => $api_response[0]['address'],

            );

            return $data;
        }
        return [];
    }
    /**
     * Retrieves posts within a certain distance from a given longitude and latitude.
     *
     * @param float $longitude The longitude of the location to search from.
     * @param float $latitude The latitude of the location to search from.
     * @param int $distance The maximum distance in kilometers from the given location.
     * @return array An array of posts within the specified distance.
     */
    public static function get_posts_in_distance($longitude, $latitude, $distance, $sort='ASC')
    {
        $sort =strtoupper($sort);

        global $wpdb;

        $prepare_query = "
        SELECT DISTINCT
            p.ID AS ID,
            pm1.meta_value AS latitude,
            pm2.meta_value AS longitude,
            (
                6371 * acos(
                    cos(radians(%f)) * cos(radians(pm1.meta_value)) *
                    cos(radians(pm2.meta_value) - radians(%f)) +
                    sin(radians(%f)) * sin(radians(pm1.meta_value))
                )
            ) AS distance
        FROM
            {$wpdb->prefix}posts AS p
        LEFT JOIN
            {$wpdb->prefix}postmeta AS pm1
            ON p.ID = pm1.post_id AND pm1.meta_key = 'latitude'
        LEFT JOIN
            {$wpdb->prefix}postmeta AS pm2
            ON p.ID = pm2.post_id AND pm2.meta_key = 'longitude'
        WHERE
            p.post_type = 'job'
            AND p.post_status = 'publish'
        HAVING distance <= %d
        ORDER BY `distance` ".$sort;

        $prepared_query = $wpdb->prepare($prepare_query, $latitude, $longitude, $latitude, $distance, strtoupper($sort));

        $result = $wpdb->get_results($prepared_query);


        $posts = [];

        foreach ($result as $lead) {
            // Do something with the lead data or store it in the posts array
            $posts[] = $lead;
        }

        return $posts;

    }
}


