<?php
/**
 * Class WishList
 * This class handles wishlist
 *
 *
 * @package LeadGenerator
 * @since 0.2.1
 */
class WishList
{
    /**
     * Constructor for the class.
     * Adds a shortcode for resetting the wishlist.
     * 
     * @return void
     */
    public function __construct()
    {
        add_shortcode('wishlist_reset', [$this, 'wishlist_reset']);
    }
    /**
     * Resets the wishlist by displaying a button to clear it.
     *
     * @return string The HTML code for the button to clear the wishlist.
     */
    public function wishlist_reset()
    {
        return '<button id="wishlist_clear" class="el-content uk-button">' . __('Merkliste löschen') . '</button>';
    }
    /**
     * Retrieves a list of jobs from the database based on the user's wishlist.
     *
     * @param array $atts Optional. An array of attributes for the shortcode.
     * @param string $content Optional. The content between the shortcode tags.
     * @return string The list of jobs retrieved from the database.
     */
    public static function my_shortcode_callback($atts, $content = null)
    {

        if (isset($_COOKIE["wishlist"])) {
            $data = $_COOKIE["wishlist"];
            $job_ids = explode(',', $data);
            $args = [
                "meta_query" => [],
                'post__in' => $job_ids
            ];
            $query = new LGenQuery();
            echo $query->query_whislist_jobs($args);


        }

    }
    /**
     * Displays the wishlist icon and the number of items in the wishlist.
     *
     * @return string The HTML code for the wishlist icon and the number of items in the wishlist.
     */
    public static function show_whistlist_icon()
    {

        if (isset($_COOKIE["wishlist"])) {
            $count = htmlspecialchars($_COOKIE["wishlist"]);
            $count_array = explode(',', $count);
            $count = count($count_array);
        } else {
            $count = 0;
        }
        return '<span class="merklist_menu_wrapper"><i class="far fa-heart"></i><span class="merkliste_text">Merkliste</span><span class="merkliste_menu">' . $count . '</span></a></span>';
    }

}



