/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./assets/js/collections/bars.js":
/*!***************************************!*\
  !*** ./assets/js/collections/bars.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Bar: () => (/* binding */ Bar)
/* harmony export */ });
/* harmony import */ var _models_bar__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../models/bar */ "./assets/js/models/bar.js");

const Bar = Backbone.Collection.extend({
  model: _models_bar__WEBPACK_IMPORTED_MODULE_0__.BarModel,
  url: function () {
    return `${dp_args.restUrl}leadgen/v1/jobs/filter/bar`;
  },
  initialize: function (options) {
    this.eventEmitter = options.eventEmitter;
    this.listenTo(this.eventEmitter, 'updateJobs', this.fetchBar.bind(this));
  },
  fetchBar: function (data) {
    console.log(data);
    this.fetch({
      model: _models_bar__WEBPACK_IMPORTED_MODULE_0__.BarModel,
      data: data,
      processData: true,
      // jQuery will convert data to a query string
      beforeSend: function (xhr) {},
      success: (collection, response, options) => {
        this.setBar(response.html);
      },
      error: function (collection, response, options) {
        console.error('Error:', options);
      }
    });
  },
  setBar: function (response) {
    const bar = document.getElementById('filter_selected_bar_selections');
    bar.innerHTML = '';
    if (bar) {
      bar.innerHTML = response;
    }
  },
  setBarEvents: function () {}
});

/***/ }),

/***/ "./assets/js/collections/jobs.js":
/*!***************************************!*\
  !*** ./assets/js/collections/jobs.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JobCollection: () => (/* binding */ JobCollection)
/* harmony export */ });
/* harmony import */ var _models_job__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../models/job */ "./assets/js/models/job.js");
/* harmony import */ var _sidebars__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./sidebars */ "./assets/js/collections/sidebars.js");
/* harmony import */ var _bars__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./bars */ "./assets/js/collections/bars.js");
/* harmony import */ var _wishlist__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../wishlist */ "./assets/js/wishlist.js");
/* harmony import */ var _scrolltotop__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../scrolltotop */ "./assets/js/scrolltotop.js");





function SortMultiValues(entries) {
  let array = [];
  for (let i = 0; i < entries.length; i++) {
    array.push(entries[i]);
  }
  return array;
}
const JobCollection = Backbone.Collection.extend({
  url: `${dp_args.restUrl}wp/v2/jobs`,
  model: _models_job__WEBPACK_IMPORTED_MODULE_0__.Job,
  perPage: 10,
  currentPage: 1,
  totalPages: 1,
  id: null,
  totalItems: 10,
  activeTerm: null,
  activeTermTaxonomy: null,
  initialize: function (options) {
    this.eventEmitter = options.eventEmitter;
    if (dp_args.activeTerm) {
      this.activeTerm = dp_args.activeTerm;
      this.activeTermTaxonomy = dp_args.activeTermTaxonomy;
    }
  },
  goToNextPage: function () {
    this.fetchJobs();
    if (this.currentPage < this.totalPages) {
      this.currentPage++;
      this.fetchJobs();
    }
  },
  goToPreviousPage: function () {
    if (this.currentPage > 1) {
      this.currentPage--;
      this.fetchJobs();
    }
  },
  updatePagination: function (totalJobs, perPage = 10, currentPage = 1, ID = 'pagination') {
    let totalPageCount = Math.ceil(totalJobs / perPage);
    if (jQuery("#tmpl-pagination-template").length) {
      let template = wp.template('pagination-template');
      let data = {
        pages: Array.from({
          length: totalPageCount
        }, (v, i) => i + 1),
        currentPage: currentPage,
        form_id: ID
      };
      console.log(totalJobs, perPage, currentPage, ID);
      if (template) {
        let paginationHTML = template(data); // Render HTML with template

        jQuery("#pagination_" + ID).html(paginationHTML);
        this.eventEmitter.emit('updatePagination');
        //    setPaginationEvent()
        this.setPaginationEvents();
      }
    }
  },
  getShortcodeFormData: function (form) {
    const data = new FormData(form);
    const trimCommasAndWhitespace = str => {
      return str.trim().split(',').filter(item => item).join(',');
    };
    let obj = {};
    obj['city'] = data.get('city');
    obj['orderby'] = data.get('orderby');
    obj['order'] = data.get('order');
    obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory')).toString();
    obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory_jobcategory_terms')).toString();
    obj['job_type'] = SortMultiValues(data.getAll('job_type')).toString();
    obj['form_of_employment_terms'] = SortMultiValues(data.getAll('job_form_of_employment_job_form_of_employment_terms')).toString();
    obj['working_time_terms'] = SortMultiValues(data.getAll('job_working_time_job_working_time_terms')).toString();
    obj['s'] = data.get('s');
    obj['per_page'] = data.get('per_page');
    obj['distance'] = data.get('distance');
    obj['latitude'] = data.get('latitude');
    obj['longitude'] = data.get('longitude');
    obj['dates'] = data.get('dates');
    obj['company_id'] = data.get('company_id');
    if (dp_args && dp_args['activeTerm']) {
      obj['jobcategory'] = trimCommasAndWhitespace(obj['jobcategory'] = obj['jobcategory'] + ',' + dp_args['activeTerm']);
      obj['activeTerm'] = dp_args['activeTerm'];
    }
    if (dp_args && dp_args['activeTermTaxonomy']) {
      obj['activeTermTaxonomy'] = dp_args['activeTermTaxonomy'];
    }
    return Object.fromEntries(Object.entries(obj).filter(([_, v]) => v != null && v != ''));
  },
  getFormData: function (form) {
    const data = new FormData(form);
    const trimCommasAndWhitespace = str => {
      return str.trim().split(',').filter(item => item).join(',');
    };
    let obj = {};
    obj['select_jobcategory'] = SortMultiValues(data.getAll('jobcategory')).toString();
    obj['select_job_form_of_employment'] = SortMultiValues(data.getAll('job_form_of_employment')).toString();
    obj['select_job_type'] = SortMultiValues(data.getAll('job_type')).toString();
    obj['select_job_working_time'] = SortMultiValues(data.getAll('job_working_time')).toString();
    obj['orderby'] = data.get('orderby');
    obj['order'] = data.get('order');
    obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory_jobcategory_terms')).toString();
    obj['job_type'] = SortMultiValues(data.getAll('job_type_job_type_terms')).toString();
    obj['form_of_employment_terms'] = SortMultiValues(data.getAll('job_form_of_employment_job_form_of_employment_terms')).toString();
    obj['working_time_terms'] = SortMultiValues(data.getAll('job_working_time_job_working_time_terms')).toString();
    obj['s'] = data.get('s');
    obj['per_page'] = data.get('per_page');
    obj['distance'] = data.get('distance');
    obj['latitude'] = data.get('latitude');
    obj['longitude'] = data.get('longitude');
    obj['dates'] = data.get('dates');
    if (dp_args && dp_args['activeTerm']) {
      obj['jobcategory'] = trimCommasAndWhitespace(obj['jobcategory'] = obj['jobcategory'] + ',' + dp_args['activeTerm']);
    }
    return Object.fromEntries(Object.entries(obj).filter(([_, v]) => v != null && v != ''));
  },
  setContainers(id) {
    this.id = id;
    this.pagination = document.getElementById('pagination-' + this.id);
    this.outputContainer = document.getElementById('dp-output-' + this.id);
  },
  handle_job(data, ID, event) {
    self = this;
    this.currentPage = data.page;
    console.log(ID);
    this.setContainers(ID);
    if (event) {
      if (event.name == 'dates') {
        this.updateSidebar(data, ID);
      }
      if (event.tagName == 'FORM') {
        this.updateSidebar(data, ID);
      }
      //jobs.updateSidebar(data, ID)
    }
    const successFunc = function (collection, response, options) {
      console.log(collection, response, options, data);
      self.eventEmitter.emit('updateJobs', data);
      return data;
    }.bind(ID);
    const errorFunc = function (collection, response, options) {
      console.error('Error:', options);
    }.bind(ID);
    const completeFunc = function (xhr, textStatus) {
      (0,_wishlist__WEBPACK_IMPORTED_MODULE_3__["default"])();
      self.updatePagination(xhr.getResponseHeader('x-wp-total'), data.per_page, self.currentPage, this);
      self.updateCount(xhr.getResponseHeader('x-wp-total'), data, ID);
    }.bind(ID);
    data.ID = ID;
    self.fetch({
      data: jQuery.param({
        ...data
      }),
      beforeSend: function (xhr) {},
      success: successFunc,
      error: errorFunc,
      complete: completeFunc
    });
  },
  setPaginationEvents: function () {
    self = this;
    let paginationElements = document.querySelectorAll('.pagination ul li span');
    Array.from(paginationElements).forEach(elem => {
      elem.addEventListener('click', function (e) {
        let clickedPage = this.getAttribute('data-page');
        if (clickedPage) {
          const pagination_ID = this.getAttribute('data-id');
          const ID = pagination_ID.split('pagination_')[0];
          const dpForms = document.querySelectorAll('.dp-form-' + ID);
          let combinedResult = {};
          let ShData = self.getShortcodeFormData(dpForms[0]);
          Array.from(dpForms).forEach(dpForm => {
            let result = self.getFormData(dpForm);
            combinedResult = Object.assign(combinedResult, result);
          });
          combinedResult = Object.assign(combinedResult, ShData);
          combinedResult['page'] = parseInt(clickedPage);
          self.handle_job(combinedResult, ID, e.target);
          (0,_scrolltotop__WEBPACK_IMPORTED_MODULE_4__.scrollToTop)(document.getElementById('dp-output-' + ID));
        }
      });
    });
  },
  parse: function (response, options) {
    var totalItems = options.xhr.getResponseHeader('X-WP-Total');
    this.totalItems = parseInt(totalItems);
    var filter_count = document.getElementById('filter_count');
    if (filter_count) filter_count.innerHTML = totalItems;
    if (filter_count && this.pagination) {
      this.outputContainer.innerHTML = '';
      this.pagination.innerHTML = '';
      let jobHTML = '';
      response.forEach(job => {
        jobHTML = jobHTML + job.rendered_job_item; // Assuming 'rendered_job_item' is the HTML field
      });
      this.outputContainer.innerHTML = jobHTML;
    } else {
      this.outputContainer.innerHTML = '';
      let jobHTML = '';
      response.forEach(job => {
        jobHTML = jobHTML + job.rendered_job_item; // Assuming 'rendered_job_item' is the HTML field
      });
      this.outputContainer.innerHTML = jobHTML;
    }
  },
  fetchJobs: function (data) {
    this.fetch({
      data: jQuery.param(data),
      processData: true,
      // jQuery will convert data to a query string
      beforeSend: function (xhr) {},
      success: (collection, response, options) => {
        // Update totalPages from the response headers

        this.updatePagination(options.xhr.getResponseHeader('X-WP-Total'), 10);
        parent_id = getOpenedAccordion();
        this.updateSidebar(data, parent_id);
      },
      error: function (collection, response, options) {
        console.error('Error:', options);
      }
    });
  },
  updateCount: function (totalJobs, data, ID) {
    let countEl = document.getElementById('count_' + ID);
    if (countEl) {
      countEl.textContent = totalJobs;
    }
  }
});

/***/ }),

/***/ "./assets/js/collections/sidebars.js":
/*!*******************************************!*\
  !*** ./assets/js/collections/sidebars.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Sidebar: () => (/* binding */ Sidebar)
/* harmony export */ });
/* harmony import */ var _models_sidebar__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../models/sidebar */ "./assets/js/models/sidebar.js");

const Sidebar = Backbone.Collection.extend({
  model: _models_sidebar__WEBPACK_IMPORTED_MODULE_0__.SidebarModel,
  url: function () {
    return `${dp_args.restUrl}leadgen/v1/jobs/filter/sidebar`;
  },
  initialize: function (options) {
    this.eventEmitter = options.eventEmitter;
    this.terms = ['job_type', 'job_working_time', 'job_form_of_employment'];
    this.listenTo(this.eventEmitter, 'updateJobs', this.fetchSidebar.bind(this));
  },
  getTaxonomies: function (ID) {
    const dpForms = document.getElementsByClassName("dp-form-" + ID);
    let combinedResult = [];
    Array.from(dpForms).forEach(dpForm => {
      const data = new FormData(dpForm);
      const dataObject = Object.fromEntries(data.entries());
      let NameArray = Object.keys(dataObject).filter(key => key.endsWith('_terms'));
      combinedResult = combinedResult.concat(NameArray);
    });
    let terms = [];
    combinedResult.forEach(name => {
      this.terms.forEach(term => {
        console.log(name.indexOf(term) !== -1);
        if (name.indexOf(term) !== -1) {
          terms.push(term);
        }
      });
    });
    return terms;
  },
  getOpenedAccordion: function (id) {
    const sidebar = document.getElementsByClassName('sidebar')[0];
    const accordions = sidebar.getElementsByClassName('uk-accordion-title');
    Array.from(accordions).forEach(accordion => {
      if (accordion.parentNode.classList.contains('uk-open')) {
        return accordion.parentNode.id;
      }
    });
  },
  fetchSidebar: function (data) {
    let terms = this.getTaxonomies(data.ID);
    console.log(data);
    this.fetch({
      model: _models_sidebar__WEBPACK_IMPORTED_MODULE_0__.SidebarModel,
      data: data,
      processData: true,
      // jQuery will convert data to a query string
      beforeSend: function (xhr) {},
      success: (collection, response, options) => {
        for (let tax in response) {
          if (terms.indexOf(tax) >= 0) {
            continue;
          } else if ('dates' == tax && 'city' in data) {
            for (let term_id in response[tax]) {
              let span = document.getElementById('term_count_' + term_id);
              if (span) {
                span.textContent = response[tax][term_id];
              }
            }
          } else if ('dates' == tax && 's' in data) {
            for (let term_id in response[tax]) {
              let span = document.getElementById('term_count_' + term_id);
              if (span) {
                span.textContent = response[tax][term_id];
              }
            }
          } else {
            for (let term_id in response[tax]) {
              let span = document.getElementById('term_count_' + term_id);
              if (span) {
                span.textContent = response[tax][term_id];
              }
            }
          }
        }
        return response;
      },
      error: function (collection, response, options) {
        console.error('Error:', options);
      }
    });
  }
});

/***/ }),

/***/ "./assets/js/filter.js":
/*!*****************************!*\
  !*** ./assets/js/filter.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wishlist__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./wishlist */ "./assets/js/wishlist.js");
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! events */ "./node_modules/events/events.js");
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(events__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _collections_jobs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./collections/jobs */ "./assets/js/collections/jobs.js");
/* harmony import */ var _collections_sidebars__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./collections/sidebars */ "./assets/js/collections/sidebars.js");
/* harmony import */ var _collections_bars__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./collections/bars */ "./assets/js/collections/bars.js");
/* harmony import */ var _models_selection__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./models/selection */ "./assets/js/models/selection.js");
/* harmony import */ var _scrolltotop__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./scrolltotop */ "./assets/js/scrolltotop.js");







function SortMultiValues(entries) {
  let array = [];
  for (let i = 0; i < entries.length; i++) {
    array.push(entries[i]);
  }
  return array;
}
const eventEmitter = new events__WEBPACK_IMPORTED_MODULE_1__();
class LeadgenFilter {
  constructor(options) {
    this.eventEmitter = options.eventEmitter;
    this.dp_form_class = options.db_form_class;
    options.filter = this;
    this.LeadgenSelection = new _models_selection__WEBPACK_IMPORTED_MODULE_5__.LeadgenSelection(options);
    this.input_types = 'input, select, textarea, checkbox';
    this.bl_input_ids = ['searchBox', 'searchInput', 'city', 'distanceDropdown'];
    this.jobs = new _collections_jobs__WEBPACK_IMPORTED_MODULE_2__.JobCollection(options);
    this.jobs.listenTo(this.eventEmitter, 'paginationEvent', this.setPaginationEvents);
  }

  /**
   * 
   * set Events
   * 
   */
  setEvents() {
    let elements = document.getElementsByName('dates');
    if (elements) {
      Array.from(elements).forEach(element => {
        element.addEventListener('change', e => {
          // If the current target was changed from checked to not checked
          if (!e.target.checked) {
            e.target.checked = false;
          } else {
            //Deselect all other checkboxes except the one currently checked
            Array.from(elements).forEach(checkbox => {
              if (checkbox !== e.target) {
                checkbox.checked = false;
              }
            });
          }
        });
      });
    }
    const dpForms = document.getElementsByClassName(this.dp_form_class);
    Array.from(dpForms).forEach(dpForm => {
      let inputs = dpForm.querySelectorAll(this.input_types);
      let sidebar_inputs = document.querySelector('.sidebar').querySelectorAll("input");
      Array.from(sidebar_inputs).forEach(input => {
        if (!this.bl_input_ids.includes(input.id)) input.addEventListener('change', e => this.handleChangeEvent(e, dpForm));
      });
      Array.from(inputs).forEach(input => {
        if (!this.bl_input_ids.includes(input.id)) input.addEventListener('change', e => this.handleChangeEvent(e, dpForm));
      });
      dpForm.addEventListener("submit", e => this.handleChangeEvent(e, dpForm));
    });
  }
  handle_job(data, ID, event) {
    self = this;
    const jobs = this.jobs;
    jobs.currentPage = data.page;
    jobs.setContainers(ID);
    console.log(ID);
    /**
    if (event) {
        if (event.name == 'dates') {
            //  jobs.updateSidebar(data, ID)
        }
        if (event.tagName == 'FORM') {
            // jobs.updateSidebar(data, ID)
        }
        //jobs.updateSidebar(data, ID)
    }
    */

    const successFunc = function (collection, response, options) {
      self.eventEmitter.emit('updateJobs', data);
      return data;
    }.bind(ID);
    const errorFunc = function (collection, response, options) {
      console.error('Error:', options);
    }.bind(ID);
    const completeFunc = function (xhr, textStatus) {
      (0,_wishlist__WEBPACK_IMPORTED_MODULE_0__["default"])();
      jobs.updatePagination(xhr.getResponseHeader('x-wp-total'), data.per_page, jobs.currentPage, this);
      jobs.updateCount(xhr.getResponseHeader('x-wp-total'), data, ID);

      // updateSidebarCount(ID);
    }.bind(ID);
    data.ID = ID;
    jobs.fetch({
      data: jQuery.param({
        ...data
      }),
      beforeSend: function (xhr) {},
      success: successFunc,
      error: errorFunc,
      complete: completeFunc
    });
  }
  splitID(classes) {
    let ID = classes.find(cls => cls.startsWith('dp-form-')).split('-')[2];
    return ID;
  }
  getID(form) {
    let classes = form.getAttribute("class").split(' ');
    return this.splitID(classes);
  }
  handleChangeEvent(e, form) {
    e.preventDefault();
    if (e.target.id) {
      const tit = document.querySelectorAll('#' + e.target.id);
      const value = e.target.checked;
      tit.forEach(term => {
        term.checked = value;
      });
    }
    let ID = this.getID(form);
    console.log('ID', ID, form);
    const dpForms = document.querySelectorAll('.dp-form-' + ID);
    let selectArrays = {};
    let combinedResult = {};
    Array.from(dpForms).forEach(dpForm => {
      let result = this.getFormData(dpForm);
      let selectArray = Object.keys(result).filter(key => key.startsWith('select_'));
      if (selectArray.length > 0) {
        selectArray.forEach(key => {
          if (selectArrays[key] == undefined) {
            selectArrays[key] = [];
          }
          selectArrays[key].push(result[key]);
        });
      }
      combinedResult = Object.assign(combinedResult, result);
    });
    combinedResult = Object.assign(combinedResult, selectArrays);
    combinedResult = Object.assign(combinedResult, getShortcodeFormData(dpForms[0]));
    this.handle_job(combinedResult, ID, e.target);
    (0,_scrolltotop__WEBPACK_IMPORTED_MODULE_6__.scrollToTop)(document.getElementById('dp-output-' + ID));
  }
  getFormData(form) {
    const data = new FormData(form);
    const trimCommasAndWhitespace = str => {
      return str.trim().split(',').filter(item => item).join(',');
    };
    let obj = {};
    obj['select_jobcategory'] = SortMultiValues(data.getAll('jobcategory')).toString();
    obj['select_job_form_of_employment'] = SortMultiValues(data.getAll('job_form_of_employment')).toString();
    obj['select_job_type'] = SortMultiValues(data.getAll('job_type')).toString();
    obj['select_job_working_time'] = SortMultiValues(data.getAll('job_working_time')).toString();
    obj['orderby'] = data.get('orderby');
    obj['order'] = data.get('order');
    obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory_jobcategory_terms')).toString();
    obj['job_type'] = SortMultiValues(data.getAll('job_type_job_type_terms')).toString();
    obj['form_of_employment_terms'] = SortMultiValues(data.getAll('job_form_of_employment_job_form_of_employment_terms')).toString();
    obj['working_time_terms'] = SortMultiValues(data.getAll('job_working_time_job_working_time_terms')).toString();
    obj['s'] = data.get('s');
    obj['per_page'] = data.get('per_page');
    obj['distance'] = data.get('distance');
    obj['latitude'] = data.get('latitude');
    obj['longitude'] = data.get('longitude');
    obj['dates'] = data.get('dates');
    if (dp_args && dp_args['activeTerm']) {
      obj['jobcategory'] = trimCommasAndWhitespace(obj['jobcategory'] = obj['jobcategory'] + ',' + dp_args['activeTerm']);
    }
    return Object.fromEntries(Object.entries(obj).filter(([_, v]) => v != null && v != ''));
  }

  /**
   * 
   * setPaginationEvents
   * 
   */
  setPaginationEvents() {
    self = this;
    let paginationElements = document.querySelectorAll('.pagination ul li span');
    Array.from(paginationElements).forEach(elem => {
      elem.addEventListener('click', function (e) {
        let clickedPage = this.getAttribute('data-page');
        if (clickedPage) {
          const pagination_ID = this.getAttribute('data-id');
          const ID = pagination_ID.split('pagination_')[0];
          const dpForms = document.querySelectorAll('.dp-form-' + ID);
          let combinedResult = {};
          let ShData = getShortcodeFormData(dpForms[0]);
          Array.from(dpForms).forEach(dpForm => {
            let result = self.getFormData(dpForm);
            combinedResult = Object.assign(combinedResult, result);
          });
          combinedResult = Object.assign(combinedResult, ShData);
          combinedResult['page'] = parseInt(clickedPage);
          self.handle_job(combinedResult, ID, e.target);
          (0,_scrolltotop__WEBPACK_IMPORTED_MODULE_6__.scrollToTop)(document.getElementById('dp-output-' + ID));
        }
      });
    });
  }
  /*  setScrollEvents() {
        self = this;
         let ids = []
        const dpForms = document.getElementsByClassName('dp-form');
        Array.from(dpForms).forEach((dpForm) => {
            ids.push(this.getID(dpForm))
       
        });
        const Ids = [... new Set(ids)]
        Ids.forEach((id) => {
             new ScrollToTop(
                'searchBtn', id
            )
        })
     }
        */
}
document.addEventListener('DOMContentLoaded', event => {
  const sidebar = document.getElementsByClassName('sidebar')[0];
  if (sidebar == undefined) {
    return;
  }
  const accordions = sidebar.getElementsByClassName('uk-accordion-title');
  Array.from(accordions).forEach(accordion => {
    accordion.addEventListener('click', function (event) {
      let parentId = event.target.parentNode.id;
      if (parentId == 'dates') {
        return;
      }
      if (parentId == 'jobcategory' || parentId == 'job_type' || parentId == 'job_form_of_employment' || parentId == 'job_working_time') {
        updateSidebarCount(parentId);
      }
    });
  });
});
function getShortcodeFormData(form) {
  const data = new FormData(form);
  const trimCommasAndWhitespace = str => {
    return str.trim().split(',').filter(item => item).join(',');
  };
  let obj = {};
  obj['city'] = data.get('city');
  obj['orderby'] = data.get('orderby');
  obj['order'] = data.get('order');
  obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory')).toString();
  obj['jobcategory'] = SortMultiValues(data.getAll('jobcategory_jobcategory_terms')).toString();
  obj['job_type'] = SortMultiValues(data.getAll('job_type')).toString();
  obj['form_of_employment_terms'] = SortMultiValues(data.getAll('job_form_of_employment_job_form_of_employment_terms')).toString();
  obj['working_time_terms'] = SortMultiValues(data.getAll('job_working_time_job_working_time_terms')).toString();
  obj['s'] = data.get('s');
  obj['per_page'] = data.get('per_page');
  obj['distance'] = data.get('distance');
  obj['latitude'] = data.get('latitude');
  obj['longitude'] = data.get('longitude');
  obj['dates'] = data.get('dates');
  obj['company_id'] = data.get('company_id');
  if (dp_args && dp_args['activeTerm']) {
    obj['jobcategory'] = trimCommasAndWhitespace(obj['jobcategory'] = obj['jobcategory'] + ',' + dp_args['activeTerm']);
    obj['activeTerm'] = dp_args['activeTerm'];
  }
  if (dp_args && dp_args['activeTermTaxonomy']) {
    obj['activeTermTaxonomy'] = dp_args['activeTermTaxonomy'];
  }
  return Object.fromEntries(Object.entries(obj).filter(([_, v]) => v != null && v != ''));
}
document.addEventListener('DOMContentLoaded', event => {
  let options = {
    db_form_class: 'dp-form',
    eventEmitter: eventEmitter
  };
  const bar = new _collections_bars__WEBPACK_IMPORTED_MODULE_4__.Bar(options);
  const sidebar = new _collections_sidebars__WEBPACK_IMPORTED_MODULE_3__.Sidebar(options);
  const filter = new LeadgenFilter(options);
  filter.setPaginationEvents();
  filter.setEvents();
  let delete_search_selected = function (object) {
    filter.LeadgenSelection.delete_search_selected(object);
  };
  let delete_selected = function (object) {
    filter.LeadgenSelection.delete_selected(object);
  };
  window.delete_selected = delete_selected;
  window.delete_search_selected = delete_search_selected;
});
jQuery(document).ready(function () {
  let button = document.getElementById("sortButton");
  if (button) {
    // Add event listener for click event
    button.addEventListener("click", function (e) {
      // Get icon by ID
      let icon = document.getElementById("sortIcon");
      let input = document.getElementById("order");

      // Check the current icon and switch
      if (icon.getAttribute("uk-icon") === "icon: arrow-down; ratio: 1.2") {
        icon.setAttribute("uk-icon", "icon: arrow-up; ratio: 1.2");
        input.value = "desc"; // change sort order to descending
      } else {
        icon.setAttribute("uk-icon", "icon: arrow-down; ratio: 1.2");
        input.value = "asc"; // change sort order to ascending
      }
      const dpForms = document.getElementsByClassName('dp-form');

      // Combined object 
      let combinedResult = {};
      Array.from(dpForms).forEach(dpForm => {
        let result = getFormData(dpForm);

        // Combine the result object into the combinedResult
        combinedResult = Object.assign(combinedResult, result);
      });
      Filter.handle_job(combinedResult, id, e.target);
    });
  }
});

/***/ }),

/***/ "./assets/js/googlemaps.js":
/*!*********************************!*\
  !*** ./assets/js/googlemaps.js ***!
  \*********************************/
/***/ (() => {

/**
 * 
 * @param {*} inputElement 
 * @param {*} options 
 */
const GooglePlacesAutocompleteWrapper = class GooglePlacesAutocomplete {
  constructor(inputElement, options = {}) {
    this.inputElement = inputElement;
    this.cityElement = document.getElementById('city');
    this.zip = document.getElementById('zip');
    this.latitudeElement = document.getElementById('latitude');
    this.longitudeElement = document.getElementById('longitude');
    this.CityclearButton = document.getElementById('CityclearButton');
    var options = {
      componentRestrictions: {
        country: 'de'
      },
      region: 'de',
      language: 'de',
      types: ['geocode'],
      suppressDefaultUI: false,
      fields: ['address_components', 'geometry', 'adr_address']
    };
    this.autocomplete = new google.maps.places.Autocomplete(inputElement, options);
    this.autocomplete.addListener('place_changed', this.onPlaceChanged.bind(this));
    this.inputElement.addEventListener('change', this.toggleClearButton.bind(this));
    this.CityclearButton.addEventListener('click', this.clearCityBox.bind(this));
  }
  toogleButtonBar() {
    if (this.inputElement.value.length > 0) {
      document.getElementById('get_current_position_wrapper').style.display = 'none';
    }
  }
  onPlaceChanged() {
    var place = this.autocomplete.getPlace();
    if (place && place.geometry && place.address_components) {
      var city = place.address_components.filter(ac => ~ac.types.indexOf('locality'))[0].long_name;
      var zip = place.address_components.filter(ac => ~ac.types.indexOf('postal_code'))[0].long_name;
      if (this.zip) {
        this.zip.value = zip;
      }
      var lat = place.geometry.location.lat();
      var lng = place.geometry.location.lng();
      this.cityElement.value = city;
      this.latitudeElement.value = lat;
      this.longitudeElement.value = lng;
      this.inputElement.value = city;
      this.toggleClearButton();
    }
  }
  getCurrentPosition() {
    let self = this;
    navigator.geolocation.getCurrentPosition(function (location) {
      var lat = location.coords.latitude;
      var lng = location.coords.longitude;
      var geocoder = new google.maps.Geocoder();
      var latlng = new google.maps.LatLng(lat, lng);
      geocoder.geocode({
        'latLng': latlng,
        'language': 'de'
      }, function (results, status) {
        console.log(results, status);
        if (status == google.maps.GeocoderStatus.OK) {
          if (results[0]) {
            var user_city = results[0].address_components.filter(ac => ~ac.types.indexOf('locality'))[0].long_name;
            document.getElementById('city').value = user_city;
            document.getElementById('searchInput').value = user_city;
            document.getElementById('latitude').value = lat;
            document.getElementById('longitude').value = lng;
            self.toogleButtonBar();
          }
        }
      });
    });
  }
  clearCityBox(event) {
    console.log('clearCityBox');
    var searchBox = document.getElementById('searchInput');
    var clearButton = document.getElementById('CityclearButton');
    clearButton.style.display = 'none';
    searchBox.value = '';
    clearButton.style.background = 'blue';
    this.cityElement.value = '';
    this.latitudeElement.value = '';
    this.longitudeElement.value = '';
    this.inputElement.value = '';
  }
  toggleClearButton() {
    console.log('toggleClearButton');
    var searchBox = document.getElementById('searchInput');
    var clearButton = document.getElementById('CityclearButton');
    if (searchBox.value.length > 0) {
      // 
    } else {}
    clearButton.style.display = 'inline-block';
  }
};

// Call the function when the document is ready
jQuery(document).ready(function () {
  let GooglePlace = new GooglePlacesAutocompleteWrapper(document.getElementById('searchInput'));
  document.getElementById('searchInput').addEventListener('focus', function (event) {
    if (event.target.value === '') {
      document.getElementById('get_current_position_wrapper').style.display = 'block';
    }
  });
  if (GooglePlace.inputElement.value.length > 0) {
    GooglePlace.toggleClearButton();
  }
  document.addEventListener('click', function (e) {
    if (e.target.id != 'searchInput') {
      if (e.target.id === 'get_current_position') {
        GooglePlace.getCurrentPosition();
        var clearButton = document.getElementById('CityclearButton');
        clearButton.style.display = 'inline-block';
      }
      document.getElementById('get_current_position_wrapper').style.display = 'none';
    }
  });
});

/***/ }),

/***/ "./assets/js/models/bar.js":
/*!*********************************!*\
  !*** ./assets/js/models/bar.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   BarModel: () => (/* binding */ BarModel)
/* harmony export */ });
const BarModel = Backbone.Model.extend({
  urlRoot: `${dp_args.restUrl}leadgen/v1/jobs/filter/bar`
});

/***/ }),

/***/ "./assets/js/models/job.js":
/*!*********************************!*\
  !*** ./assets/js/models/job.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Job: () => (/* binding */ Job)
/* harmony export */ });
const Job = Backbone.Model.extend({
  urlRoot: `${dp_args.restUrl}wp/v2/jobs`
});

/***/ }),

/***/ "./assets/js/models/selection.js":
/*!***************************************!*\
  !*** ./assets/js/models/selection.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   LeadgenSelection: () => (/* binding */ LeadgenSelection)
/* harmony export */ });
const LeadgenSelection = class LeadgenSelection {
  constructor(options) {
    this.eventEmitter = options.eventEmitter;
    this.form_id = options.form_id;
    this.form = document.getElementById(this.form_id);
    this.bar = '';
    this.filter = options.filter;
    this.dp_form_class = options.db_form_class;
    this.dp_forms = document.getElementsByClassName(this.dp_form_class);
    this.jobcategory_filter_select = document.getElementById("jobcategory_filter_select");
  }
  delete_search_selected(obj) {
    let combinedResult = {};
    Array.from(this.dp_forms).forEach(dpForm => {
      let result = this.filter.getFormData(dpForm);
      if (result.s) {
        delete result.s;
        jQuery('.searchFormWrapper').each(function () {
          // Find the input field with name 's'
          var inputS = jQuery(this).find('input[name=s]');
          // Replace input value and set placeholder
          inputS.val('');
          inputS.attr('placeholder', 'Suche');
        });
      }
      combinedResult = Object.assign(combinedResult, result);
    });
    const FormElements = document.querySelectorAll('form[class*="dp-form-"]');
    let classes = FormElements[0].getAttribute("class").split(' ');
    let id = classes.find(cls => cls.startsWith('dp-form-')).split('-')[2];
    this.filter.handle_job(combinedResult, id);
  }
  delete_selected(obj) {
    const FormElements = document.querySelectorAll('form[class*="dp-form-"]');
    let classes = FormElements[0].getAttribute("class").split(' ');
    let id = classes.find(cls => cls.startsWith('dp-form-')).split('-')[2];
    const dpForms = document.getElementsByClassName('dp-form-' + id);
    this.resetSelection(obj);
    let combinedResult = {};
    Array.from(dpForms).forEach(dpForm => {
      let result = this.filter.getFormData(dpForm);
      combinedResult = Object.assign(combinedResult, result);
    });
    this.filter.handle_job(combinedResult, id);
  }
  parse_throught_selected_bar() {
    let jobcategory_filter_select = document.getElementById(this.jobcategory_filter_select);
    if (jobcategory_filter_select) {
      for (let i = 0; i < jobcategory_filter_select.children.length; i++) {
        jobcategory_filter_select.children[i].addEventListener("click", function (event) {
          this.delete_selected(event);
        });
      }
    }
  }
  resetSelection(selectedOption) {
    if (selectedOption.classList.contains("city")) {
      let city = document.getElementById("city");
      var searchBox = document.getElementById('searchInput');
      document.getElementById('latitude').value = '';
      document.getElementById('longitude').value = '';
      searchBox.value = '';
      city.value = '';
      document.getElementById('CityclearButton').style.display = 'none';
    } else if (selectedOption.hasAttribute('data-id')) {
      let option_id = selectedOption.getAttribute('data-id');
      if (option_id == dp_args.activeTerm) {
        window.location.href = dp_args.jobArchive;
      } else {
        if (selectedOption.classList.contains("datefilter")) {
          let checkbox = document.getElementById("date_" + option_id);
          if (checkbox) {
            checkbox.checked = false;
            let all_checkbox = document.getElementById("date_-9000");
            all_checkbox.checked = true;
          }
        } else {
          let checkbox = jQuery("input[id$='term_" + option_id + "']");
          if (checkbox) {
            //checkbox.checked = false;
            checkbox.prop('checked', false);
          }
        }
      }
      if (option_id) {
        selectedOption.remove();
      }
    }
  }
};

/***/ }),

/***/ "./assets/js/models/sidebar.js":
/*!*************************************!*\
  !*** ./assets/js/models/sidebar.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SidebarModel: () => (/* binding */ SidebarModel)
/* harmony export */ });
const SidebarModel = Backbone.Model.extend({
  urlRoot: `${dp_args.restUrl}leadgen/v1/jobs/filter/sidebar`
});

/***/ }),

/***/ "./assets/js/scrolltotop.js":
/*!**********************************!*\
  !*** ./assets/js/scrolltotop.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   scrollToTop: () => (/* binding */ scrollToTop)
/* harmony export */ });
function scrollToTop(target) {
  window.scrollTo({
    top: target.getBoundingClientRect().top + window.scrollY - 120,
    behavior: 'smooth'
  });
}

/***/ }),

/***/ "./assets/js/selected.js":
/*!*******************************!*\
  !*** ./assets/js/selected.js ***!
  \*******************************/
/***/ (() => {



/***/ }),

/***/ "./assets/js/wishlist.js":
/*!*******************************!*\
  !*** ./assets/js/wishlist.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
// Function to check if a cookie exists
function getCookie(name) {
  const cookieString = document.cookie;
  const cookies = cookieString.split("; ");
  for (let i = 0; i < cookies.length; i++) {
    const cookie = cookies[i].split("=");
    if (cookie[0] === name) {
      return cookie[1];
    }
  }
  return null;
}

// Function to add a new cookie
function setCookie(name, value) {
  delete_cookie(name);
  document.cookie = `${name}=${value}; path=/`;
}
function deleteIdfromCookie(cookieStr, Id) {
  let idArray = cookieStr.split(',');
  idArray.splice(idArray.indexOf(Id), 1);
  return idArray;
}
const count_values = text => {
  if (text) {
    let m_array = text.split(",");
    let notNullCount = m_array.filter(item => item != "null").length;
    return notNullCount;
  } else {
    return 0;
  }
};

// Function to handle click on wishlist element
function handleClick(event) {
  const wishlistElement = event.target;
  const dataId = wishlistElement.parentElement.getAttribute("data-id");
  const existingWishlist = getCookie("wishlist") || "";
  console.log(existingWishlist, dataId, wishlistElement);
  if (!getCookie("wishlist") || !getCookie("wishlist").includes(dataId)) {
    if (existingWishlist) {
      const updatedWishlist = `${existingWishlist},${dataId}`;
      setCookie("wishlist", updatedWishlist);
    } else {
      setCookie("wishlist", dataId);
    }
    wishlistElement.className = "fas fa-heart";
  } else {
    let NewexistingWishlist = deleteIdfromCookie(existingWishlist, dataId);
    if (NewexistingWishlist != '') {
      setCookie("wishlist", NewexistingWishlist.toString());
      wishlistElement.className = "far fa-heart";
    } else {
      delete_cookie("wishlist");
      console.log('delete');
      wishlistElement.className = "far fa-heart";
    }
  }
  event.preventDefault();
  let wishlist = getCookie("wishlist");
  let value = count_values(wishlist);
  replace_counts(value);
}
const set_event_watcher = () => {
  let value = count_values(getCookie("wishlist"));
  replace_counts(value);
  let wishlistElements = document.getElementsByClassName("wishlist");

  // Attach click event handler to each 'wishlist' element
  for (let i = 0; i < wishlistElements.length; i++) {
    if (getCookie("wishlist")) {
      let idArray = getCookie("wishlist").split(',');
      if (idArray.includes(wishlistElements[i].getAttribute("data-id"))) {
        console.log(wishlistElements[i].getAttribute("data-id"));
        wishlistElements[i].children[0].className = "fas fa-heart";
      }
    }
    let spanElements = wishlistElements[i].querySelectorAll("i");
    spanElements.forEach(span => {
      span.addEventListener("click", handleClick);
    });
  }
};
const replace_counts = value => {
  let elements = document.getElementsByClassName('merkliste_menu');
  if (value != undefined) {
    for (let i = 0; i < elements.length; i++) {
      elements[i].innerHTML = value;
    }
  }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (set_event_watcher);
document.addEventListener('DOMContentLoaded', function () {
  set_event_watcher();
});
document.addEventListener('DOMContentLoaded', function () {
  const wishlistElements = document.getElementsByClassName("wishlist");

  // Attach click event handler to each 'wishlist' element
  for (let i = 0; i < wishlistElements.length; i++) {
    if (getCookie("wishlist")) {
      let idArray = getCookie("wishlist").split(',');
      if (idArray.includes(wishlistElements[i].getAttribute("data-id"))) {
        wishlistElements[i].children[0].className = "fas fa-heart";
      }
    }
  }
}, false);
function delete_cookie(name) {
  document.cookie = name + '=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;';
}
document.addEventListener('DOMContentLoaded', function () {
  let wishlistButton = document.getElementById("wishlist_clear");
  if (wishlistButton) {
    wishlistButton.addEventListener("click", function () {
      delete_cookie("wishlist");
      location.reload();
    });
  }
});

/***/ }),

/***/ "./node_modules/events/events.js":
/*!***************************************!*\
  !*** ./node_modules/events/events.js ***!
  \***************************************/
/***/ ((module) => {

"use strict";
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.



var R = typeof Reflect === 'object' ? Reflect : null
var ReflectApply = R && typeof R.apply === 'function'
  ? R.apply
  : function ReflectApply(target, receiver, args) {
    return Function.prototype.apply.call(target, receiver, args);
  }

var ReflectOwnKeys
if (R && typeof R.ownKeys === 'function') {
  ReflectOwnKeys = R.ownKeys
} else if (Object.getOwnPropertySymbols) {
  ReflectOwnKeys = function ReflectOwnKeys(target) {
    return Object.getOwnPropertyNames(target)
      .concat(Object.getOwnPropertySymbols(target));
  };
} else {
  ReflectOwnKeys = function ReflectOwnKeys(target) {
    return Object.getOwnPropertyNames(target);
  };
}

function ProcessEmitWarning(warning) {
  if (console && console.warn) console.warn(warning);
}

var NumberIsNaN = Number.isNaN || function NumberIsNaN(value) {
  return value !== value;
}

function EventEmitter() {
  EventEmitter.init.call(this);
}
module.exports = EventEmitter;
module.exports.once = once;

// Backwards-compat with node 0.10.x
EventEmitter.EventEmitter = EventEmitter;

EventEmitter.prototype._events = undefined;
EventEmitter.prototype._eventsCount = 0;
EventEmitter.prototype._maxListeners = undefined;

// By default EventEmitters will print a warning if more than 10 listeners are
// added to it. This is a useful default which helps finding memory leaks.
var defaultMaxListeners = 10;

function checkListener(listener) {
  if (typeof listener !== 'function') {
    throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof listener);
  }
}

Object.defineProperty(EventEmitter, 'defaultMaxListeners', {
  enumerable: true,
  get: function() {
    return defaultMaxListeners;
  },
  set: function(arg) {
    if (typeof arg !== 'number' || arg < 0 || NumberIsNaN(arg)) {
      throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + arg + '.');
    }
    defaultMaxListeners = arg;
  }
});

EventEmitter.init = function() {

  if (this._events === undefined ||
      this._events === Object.getPrototypeOf(this)._events) {
    this._events = Object.create(null);
    this._eventsCount = 0;
  }

  this._maxListeners = this._maxListeners || undefined;
};

// Obviously not all Emitters should be limited to 10. This function allows
// that to be increased. Set to zero for unlimited.
EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
  if (typeof n !== 'number' || n < 0 || NumberIsNaN(n)) {
    throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + n + '.');
  }
  this._maxListeners = n;
  return this;
};

function _getMaxListeners(that) {
  if (that._maxListeners === undefined)
    return EventEmitter.defaultMaxListeners;
  return that._maxListeners;
}

EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
  return _getMaxListeners(this);
};

EventEmitter.prototype.emit = function emit(type) {
  var args = [];
  for (var i = 1; i < arguments.length; i++) args.push(arguments[i]);
  var doError = (type === 'error');

  var events = this._events;
  if (events !== undefined)
    doError = (doError && events.error === undefined);
  else if (!doError)
    return false;

  // If there is no 'error' event listener then throw.
  if (doError) {
    var er;
    if (args.length > 0)
      er = args[0];
    if (er instanceof Error) {
      // Note: The comments on the `throw` lines are intentional, they show
      // up in Node's output if this results in an unhandled exception.
      throw er; // Unhandled 'error' event
    }
    // At least give some kind of context to the user
    var err = new Error('Unhandled error.' + (er ? ' (' + er.message + ')' : ''));
    err.context = er;
    throw err; // Unhandled 'error' event
  }

  var handler = events[type];

  if (handler === undefined)
    return false;

  if (typeof handler === 'function') {
    ReflectApply(handler, this, args);
  } else {
    var len = handler.length;
    var listeners = arrayClone(handler, len);
    for (var i = 0; i < len; ++i)
      ReflectApply(listeners[i], this, args);
  }

  return true;
};

function _addListener(target, type, listener, prepend) {
  var m;
  var events;
  var existing;

  checkListener(listener);

  events = target._events;
  if (events === undefined) {
    events = target._events = Object.create(null);
    target._eventsCount = 0;
  } else {
    // To avoid recursion in the case that type === "newListener"! Before
    // adding it to the listeners, first emit "newListener".
    if (events.newListener !== undefined) {
      target.emit('newListener', type,
                  listener.listener ? listener.listener : listener);

      // Re-assign `events` because a newListener handler could have caused the
      // this._events to be assigned to a new object
      events = target._events;
    }
    existing = events[type];
  }

  if (existing === undefined) {
    // Optimize the case of one listener. Don't need the extra array object.
    existing = events[type] = listener;
    ++target._eventsCount;
  } else {
    if (typeof existing === 'function') {
      // Adding the second element, need to change to array.
      existing = events[type] =
        prepend ? [listener, existing] : [existing, listener];
      // If we've already got an array, just append.
    } else if (prepend) {
      existing.unshift(listener);
    } else {
      existing.push(listener);
    }

    // Check for listener leak
    m = _getMaxListeners(target);
    if (m > 0 && existing.length > m && !existing.warned) {
      existing.warned = true;
      // No error code for this since it is a Warning
      // eslint-disable-next-line no-restricted-syntax
      var w = new Error('Possible EventEmitter memory leak detected. ' +
                          existing.length + ' ' + String(type) + ' listeners ' +
                          'added. Use emitter.setMaxListeners() to ' +
                          'increase limit');
      w.name = 'MaxListenersExceededWarning';
      w.emitter = target;
      w.type = type;
      w.count = existing.length;
      ProcessEmitWarning(w);
    }
  }

  return target;
}

EventEmitter.prototype.addListener = function addListener(type, listener) {
  return _addListener(this, type, listener, false);
};

EventEmitter.prototype.on = EventEmitter.prototype.addListener;

EventEmitter.prototype.prependListener =
    function prependListener(type, listener) {
      return _addListener(this, type, listener, true);
    };

function onceWrapper() {
  if (!this.fired) {
    this.target.removeListener(this.type, this.wrapFn);
    this.fired = true;
    if (arguments.length === 0)
      return this.listener.call(this.target);
    return this.listener.apply(this.target, arguments);
  }
}

function _onceWrap(target, type, listener) {
  var state = { fired: false, wrapFn: undefined, target: target, type: type, listener: listener };
  var wrapped = onceWrapper.bind(state);
  wrapped.listener = listener;
  state.wrapFn = wrapped;
  return wrapped;
}

EventEmitter.prototype.once = function once(type, listener) {
  checkListener(listener);
  this.on(type, _onceWrap(this, type, listener));
  return this;
};

EventEmitter.prototype.prependOnceListener =
    function prependOnceListener(type, listener) {
      checkListener(listener);
      this.prependListener(type, _onceWrap(this, type, listener));
      return this;
    };

// Emits a 'removeListener' event if and only if the listener was removed.
EventEmitter.prototype.removeListener =
    function removeListener(type, listener) {
      var list, events, position, i, originalListener;

      checkListener(listener);

      events = this._events;
      if (events === undefined)
        return this;

      list = events[type];
      if (list === undefined)
        return this;

      if (list === listener || list.listener === listener) {
        if (--this._eventsCount === 0)
          this._events = Object.create(null);
        else {
          delete events[type];
          if (events.removeListener)
            this.emit('removeListener', type, list.listener || listener);
        }
      } else if (typeof list !== 'function') {
        position = -1;

        for (i = list.length - 1; i >= 0; i--) {
          if (list[i] === listener || list[i].listener === listener) {
            originalListener = list[i].listener;
            position = i;
            break;
          }
        }

        if (position < 0)
          return this;

        if (position === 0)
          list.shift();
        else {
          spliceOne(list, position);
        }

        if (list.length === 1)
          events[type] = list[0];

        if (events.removeListener !== undefined)
          this.emit('removeListener', type, originalListener || listener);
      }

      return this;
    };

EventEmitter.prototype.off = EventEmitter.prototype.removeListener;

EventEmitter.prototype.removeAllListeners =
    function removeAllListeners(type) {
      var listeners, events, i;

      events = this._events;
      if (events === undefined)
        return this;

      // not listening for removeListener, no need to emit
      if (events.removeListener === undefined) {
        if (arguments.length === 0) {
          this._events = Object.create(null);
          this._eventsCount = 0;
        } else if (events[type] !== undefined) {
          if (--this._eventsCount === 0)
            this._events = Object.create(null);
          else
            delete events[type];
        }
        return this;
      }

      // emit removeListener for all listeners on all events
      if (arguments.length === 0) {
        var keys = Object.keys(events);
        var key;
        for (i = 0; i < keys.length; ++i) {
          key = keys[i];
          if (key === 'removeListener') continue;
          this.removeAllListeners(key);
        }
        this.removeAllListeners('removeListener');
        this._events = Object.create(null);
        this._eventsCount = 0;
        return this;
      }

      listeners = events[type];

      if (typeof listeners === 'function') {
        this.removeListener(type, listeners);
      } else if (listeners !== undefined) {
        // LIFO order
        for (i = listeners.length - 1; i >= 0; i--) {
          this.removeListener(type, listeners[i]);
        }
      }

      return this;
    };

function _listeners(target, type, unwrap) {
  var events = target._events;

  if (events === undefined)
    return [];

  var evlistener = events[type];
  if (evlistener === undefined)
    return [];

  if (typeof evlistener === 'function')
    return unwrap ? [evlistener.listener || evlistener] : [evlistener];

  return unwrap ?
    unwrapListeners(evlistener) : arrayClone(evlistener, evlistener.length);
}

EventEmitter.prototype.listeners = function listeners(type) {
  return _listeners(this, type, true);
};

EventEmitter.prototype.rawListeners = function rawListeners(type) {
  return _listeners(this, type, false);
};

EventEmitter.listenerCount = function(emitter, type) {
  if (typeof emitter.listenerCount === 'function') {
    return emitter.listenerCount(type);
  } else {
    return listenerCount.call(emitter, type);
  }
};

EventEmitter.prototype.listenerCount = listenerCount;
function listenerCount(type) {
  var events = this._events;

  if (events !== undefined) {
    var evlistener = events[type];

    if (typeof evlistener === 'function') {
      return 1;
    } else if (evlistener !== undefined) {
      return evlistener.length;
    }
  }

  return 0;
}

EventEmitter.prototype.eventNames = function eventNames() {
  return this._eventsCount > 0 ? ReflectOwnKeys(this._events) : [];
};

function arrayClone(arr, n) {
  var copy = new Array(n);
  for (var i = 0; i < n; ++i)
    copy[i] = arr[i];
  return copy;
}

function spliceOne(list, index) {
  for (; index + 1 < list.length; index++)
    list[index] = list[index + 1];
  list.pop();
}

function unwrapListeners(arr) {
  var ret = new Array(arr.length);
  for (var i = 0; i < ret.length; ++i) {
    ret[i] = arr[i].listener || arr[i];
  }
  return ret;
}

function once(emitter, name) {
  return new Promise(function (resolve, reject) {
    function errorListener(err) {
      emitter.removeListener(name, resolver);
      reject(err);
    }

    function resolver() {
      if (typeof emitter.removeListener === 'function') {
        emitter.removeListener('error', errorListener);
      }
      resolve([].slice.call(arguments));
    };

    eventTargetAgnosticAddListener(emitter, name, resolver, { once: true });
    if (name !== 'error') {
      addErrorHandlerIfEventEmitter(emitter, errorListener, { once: true });
    }
  });
}

function addErrorHandlerIfEventEmitter(emitter, handler, flags) {
  if (typeof emitter.on === 'function') {
    eventTargetAgnosticAddListener(emitter, 'error', handler, flags);
  }
}

function eventTargetAgnosticAddListener(emitter, name, listener, flags) {
  if (typeof emitter.on === 'function') {
    if (flags.once) {
      emitter.once(name, listener);
    } else {
      emitter.on(name, listener);
    }
  } else if (typeof emitter.addEventListener === 'function') {
    // EventTarget does not have `error` event semantics like Node
    // EventEmitters, we do not listen for `error` events here.
    emitter.addEventListener(name, function wrapListener(arg) {
      // IE does not have builtin `{ once: true }` support so we
      // have to do it manually.
      if (flags.once) {
        emitter.removeEventListener(name, wrapListener);
      }
      listener(arg);
    });
  } else {
    throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type ' + typeof emitter);
  }
}


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry needs to be wrapped in an IIFE because it needs to be in strict mode.
(() => {
"use strict";
/*!***************************!*\
  !*** ./assets/js/main.js ***!
  \***************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wishlist__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./wishlist */ "./assets/js/wishlist.js");
/* harmony import */ var _selected__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./selected */ "./assets/js/selected.js");
/* harmony import */ var _selected__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_selected__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _filter__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./filter */ "./assets/js/filter.js");
/* harmony import */ var _googlemaps__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./googlemaps */ "./assets/js/googlemaps.js");
/* harmony import */ var _googlemaps__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_googlemaps__WEBPACK_IMPORTED_MODULE_3__);




const getOpenedAccordion = function () {
  const sidebar = document.getElementsByClassName('sidebar')[0];
  const accordions = sidebar.getElementsByClassName('uk-accordion-title');
  Array.from(accordions).forEach(accordion => {
    if (accordion.parentNode.classList.contains('uk-open')) {
      return accordion.parentNode.id;
    }
  });
};

/*
jQuery(document).ready(function () {
  // Extract product_id from URL
  let url_string = window.location.href;
  let url = new URL(url_string);
  let product_id = url.searchParams.get("product_id");

  // Set the matching option in the select dropdown to active
  jQuery('select[name="product[]product_lead"]').val(product_id);

  jQuery(function () {
    jQuery("#searchInput").autocomplete({
      source: function (request, response) {
        jQuery.ajax({
          url: dp_args.restUrl + "leadgen/v1/jobs/address/autocomplete",
          data: { term: request.term },
          success: function (data) {

            const mappedData = data.map(item => ({
              label: item.zip + ' ' + item.city + ' ' + item.district,
              value: item.zip + ' ' + item.city + ' ' + item.district,
              lat: item.latitude,
              long: item.longitude,
              zip: item.zip,
              city: item.city,
              district: item.district
            }));
            response(mappedData);
          }
        });
      },
      select: function (event, ui) {
        // Action when a list item is selected

      },
      // Custom rendering
      _renderItem: function (ul, item) {
        var el = $("<li></li>")
          .attr("data-lat", item.lat)
          .attr("data-long", item.long)
          .attr("data-country", item.country)
          .attr("data-zip", item.zip)
          .attr("data-city", item.city)
          .attr("data-district", item.district)

          .appendTo(ul);
        jQuery("<a>", { text: item.label }).appendTo(el);
        return el;
      },

      select: function (event, ui) {

        // Set values of latitude and longitude fields with ui's lat and long
        jQuery('#latitude').val(ui.item.lat);
        jQuery('#longitude').val(ui.item.long);
        jQuery('#zip').val(ui.item.zip);
        jQuery('#city').val(ui.item.city);
        jQuery('#district').val(ui.item.district);

      },
    });
  });

});
*/
document.addEventListener('DOMContentLoaded', function () {
  var removeImageBtn = document.querySelector('.remove-image');
  var cf7Inputs = document.querySelectorAll('input.images');
  cf7Inputs.forEach(function (cf7Input) {
    cf7Input.addEventListener('change', function (e) {
      var reader = new FileReader();
      reader.onload = function (event) {
        var filePreview = cf7Input.closest('.uk-margin').querySelector('img.preview');
        var previewCard = cf7Input.closest('.uk-margin').querySelector('.preview-card');
        filePreview.src = event.target.result;
        // Show the preview-card when image is uploaded
        previewCard.style.display = "block";
      };
      reader.readAsDataURL(e.target.files[0]);
    });
    removeImageBtn.addEventListener('click', function (e) {
      e.preventDefault();
      var filePreview = cf7Input.closest('.uk-margin').querySelector('img.preview');
      var previewCard = cf7Input.closest('.uk-margin').querySelector('.preview-card');
      filePreview.src = ''; // Or set to a default/placeholder image
      cf7Input.value = ''; // Clear the value of CF7 input
      // Hide the preview-card when image is removed
      previewCard.style.display = "none";
    });
  });
});
document.addEventListener('wpcf7beforesubmit', function (event) {
  jQuery('.wpcf7-not-valid-tip').remove();
}, false);
document.addEventListener('wpcf7mailsent', function (event) {
  if ('mail_sent' == event.detail.status) {
    let currentUrl = new URL(window.location.href);
    currentUrl.searchParams.set('success', 'true');
    currentUrl.searchParams.delete('post_id');
    location = currentUrl.href;
  }
}, false);
document.addEventListener('DOMContentLoaded', function () {
  let selectElement = document.querySelector('select[name="job_company"]');
  if (selectElement) {
    selectElement.addEventListener('change', function () {
      if (this.value === 'new') {
        document.getElementById('custom-input').style.display = 'block';
        var selectedOptionText = this.options[this.selectedIndex].innerText;
        var hiddenElement = document.querySelector('input[name="company_id"]');
        var hiddenTextElement = document.querySelector('input[name="job_company"]');
        if (hiddenElement) {
          hiddenElement.value = '';
          hiddenTextElement.value = selectedOptionText;
        }
      } else {
        document.getElementById('custom-input').style.display = 'none';
        var selectedOptionText = this.options[this.selectedIndex].innerText;
        var hiddenElement = document.querySelector('input[name="company_id"]');
        var hiddenTextElement = document.querySelector('input[name="job_company"]');
        if (hiddenElement) {
          var value = this.options[this.selectedIndex].dataset.value; // not this.dataset.value
          hiddenElement.value = value;
          hiddenTextElement.value = selectedOptionText;
        }
      }
    });
  }
});
})();

/******/ })()
;
//# sourceMappingURL=main.js.map