<?php
/**
 * Groups an array of shortcodes by their class.
 *
 * @param array $shortcodes An array of shortcodes to be grouped.
 * @return array An array of grouped shortcodes, with the class name as the key.
 */
function groupShortcodesByClass($shortcodes)
{
    $grouped = [];
    foreach ($shortcodes as $shortcode) {
        $grouped[$shortcode['class']][] = $shortcode;
    }
    return $grouped;
}

$shortcodes = [
    [
        'name' => 'wishlist_icon',
        'function' => 'show_wishlist_icon',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist icon für einen single Lead an',
        'example' => '[wishlist]',
        'class' => 'wishlist'

    ],
    [
        'name' => 'wishlist',
        'function' => 'wishlist',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist auf einer Seite an',
        'example' => '[wishlist]',
        'class' => 'wishlist'
    ],
    [
        'name' => 'wishlist_reset',
        'function' => 'wishlist_reset',
        'args' => ['test'],
        'description' => 'Erzeugt einen Button, welcher die Wishlist des Besuchers löschen kann',
        'example' => '[wishlist]',
        'class' => 'wishlist'
    ],
    [
        'name' => 'show_heart',
        'function' => 'show_heart',
        'args' => ['job_id'],
        'description' => 'Erzeugt ein Herz mit  data-id des zu speicherndem Job ID',
        'example' => '[show_heart]',

    ],
    [
        'name' => 'product_panel',
        'function' => 'show_product_panel',
        'args' => ['product_id'],
        'description' => 'product panel zeigt ein CardPanel eines Produktes inkl. Link (/job-einstellen/) zum Formular an.',
        'example' => '[product_panel product_id=1126]',
        'class' => 'product'
    ],
    [
        'name' => 'job_terms_list',
        'function' => 'query_custom_terms',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist auf einer Seite an',
        'example' => '[job_terms_list]',
        'class' => 'map'
    ],
    [
        'name' => 'openstreetmap',
        'function' => 'map_shortcode',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist auf einer Seite an',
        'example' => '[openstreetmap]',
        'class' => 'map'
    ],

    [
        'name' => 'filter_jobs',
        'function' => 'render_complete_filter',
        'args' => [''],
        'description' => 'zeigt den Filter an',
        'example' => '[wishlist]',
        'class' => 'wishlist'
    ],

    [
        'name' => 'filter_sort',
        'function' => 'show_sorting',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist auf einer Seite an',
        'example' => '[wishlist]',
        'class' => 'wishlist'
    ],

    [
        'name' => 'filter_selected',
        'function' => 'filter_selected',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist auf einer Seite an',
        'example' => '[wishlist]',
        'class' => 'wishlist'
    ],

    [
        'name' => 'search_form',
        'function' => 'search_form_shortcode',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist auf einer Seite an',
        'example' => '[wishlist]',
        'class' => 'wishlist'
    ]
    ,

    [
        'name' => 'accept_job',
        'function' => 'accept_uuid',
        'args' => ['test'],
        'description' => 'zeigt das Wishlist auf einer Seite an',
        'example' => '[wishlist]',
        'class' => 'wishlist'
    ]
];