### LWM Admin Pages

Example:

```php
if( is_admin() ) {
    $plugin_slug = trim( dirname( plugin_basename( __FILE__ ) ) );

    $admin_page = new Lightweb_Media\Lightweb_Media_Admin_Pages\LWM_Admin_Pages(
        $plugin_slug,
        'MY Plugin Title',
        'MY Plugin Menu Title',
        'manage_options',
        function() {
            echo '<h1>MY Plugin Title</h1>';
        }
    );

    $admin_page->add_subpage(
        $plugin_slug . '-settings',
        'Settings',
        'Settings',
        function() {
            echo '<h1>Settings</h1>';
        }
    );

    // $admin_page->add_subpage(...)
}
```

Add Form

```php
    // ..
    $options_page_1 = new Lightweb_Media\Lightweb_Media_Admin_Pages\LWM_Admin_Forms(
        'zzz', 
        [
            [
                'id' => 'license_key',
                'title' => __('License Key', 'zzz'),
            ], [
                'id' => 'foo',
                'title' => __('Foo', 'zzz'),
            ]
        ]
    );

    $options_page_2 = new Lightweb_Media\Lightweb_Media_Admin_Pages\LWM_Admin_Forms(
        'zzz_sub', 
        // ...
    );
    
    $admin_page = new Lightweb_Media\Lightweb_Media_Admin_Pages\LWM_Admin_Pages(
        $plugin_slug,
        'MY Plugin Title',
        'MY Plugin Menu Title',
        'manage_options',
        [$options_page_1, 'render_options_page']
    );

    $admin_page->add_subpage(
        // ..
        [$options_page_2, 'render_options_page']
    );
```